#ifndef INC_ASTParser_hpp_
#define INC_ASTParser_hpp_

#include <antlr/config.hpp>
#include "SourceParserTokenTypes.hpp"
/* $ANTLR 2.7.5 (20050201): "parser.g" -> "ASTParser.hpp"$ */
#include <antlr/TreeParser.hpp>

#line 10 "parser.g"

	#include <iostream>

	#include "CodeGenerator.h"
	#include "Symbols.h"
	#include "Utilities.h"
	
	using namespace std;
	using namespace Compiler;

#line 21 "ASTParser.hpp"
#line 6 "parser.g"

	#include "ANTLRExt.h"

#line 26 "ASTParser.hpp"
class CUSTOM_API ASTParser : public ANTLR_USE_NAMESPACE(antlr)TreeParser, public SourceParserTokenTypes
{
#line 611 "parser.g"

	// For each block we need to know whether a returned value from
	// a function is used or not, so we can adjust the expression
	// stack pointer accordingly upon return. Here I just find each
	// such top-level call and set the indicator, so when we get to
	// the call node we can check if it's a top-level call.
	//
	void findTopLevelCalls(RefASTNodeExt startNode, bool skipFirstChild = false) {
		RefASTNodeExt node = RefASTNodeExt(startNode->getFirstChild());
		
		if (skipFirstChild) {
			node = node->getNextSibling();
		}
		
		while (node) {
			if (node->getType() == CALL) {
				node->isTopLevelCall = true;
			}
			
			node = node->getNextSibling();
		}
	}
	
	void ERROR_IF(bool cond, int line, string msg) {
		if (cond) {
			throw CompilerException(line, msg);
		}
	}
#line 30 "ASTParser.hpp"
public:
	ASTParser();
	static void initializeASTFactory( ANTLR_USE_NAMESPACE(antlr)ASTFactory& factory );
	int getNumTokens() const
	{
		return ASTParser::NUM_TOKENS;
	}
	const char* getTokenName( int type ) const
	{
		if( type > getNumTokens() ) return 0;
		return ASTParser::tokenNames[type];
	}
	const char* const* getTokenNames() const
	{
		return ASTParser::tokenNames;
	}
	public: void start(RefASTNodeExt _t);
	public: void functionDef(RefASTNodeExt _t);
	public: void forward(RefASTNodeExt _t);
	public: Symbol*  declaration(RefASTNodeExt _t,
		bool isParameter = false, bool createSymbol = false
	);
	public: void block(RefASTNodeExt _t,
		bool createScope = true, Symbol* function = 0
	);
	public: TypeAttr  typeSpec(RefASTNodeExt _t);
	public: void statement(RefASTNodeExt _t);
	public: void continueStmt(RefASTNodeExt _t);
	public: void breakStmt(RefASTNodeExt _t);
	public: void loop(RefASTNodeExt _t);
	public: void ifElse(RefASTNodeExt _t);
	public: void returnExpression(RefASTNodeExt _t);
	public: void simpleStatement(RefASTNodeExt _t);
	public: void inputOutputStmt(RefASTNodeExt _t);
	public: void paramList(RefASTNodeExt _t,
		Symbol* fn
	);
	public: TypeAttr  expression(RefASTNodeExt _t);
	public: Symbol*  identifier(RefASTNodeExt _t,
		bool genCode = true
	);
	public: void statementList(RefASTNodeExt _t);
	public: vector<int>  arrayTypeSpec(RefASTNodeExt _t);
	public: void incDec(RefASTNodeExt _t);
	public: void assignment(RefASTNodeExt _t);
	public: TypeAttr  reference(RefASTNodeExt _t,
		bool isLValue = false, bool genZeroOffset = false
	);
	public: TypeAttr  arrayAccess(RefASTNodeExt _t);
	public: TypeAttr  functionCall(RefASTNodeExt _t);
	public: TypeAttr  primaryExpr(RefASTNodeExt _t);
	public: vector<TypeAttr>  args(RefASTNodeExt _t);
	public: TypeAttr  postfixExpr(RefASTNodeExt _t);
	public: Constant  constant(RefASTNodeExt _t);
public:
	ANTLR_USE_NAMESPACE(antlr)RefAST getAST()
	{
		return ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST);
	}
	
protected:
	RefASTNodeExt returnAST;
	RefASTNodeExt _retTree;
private:
	static const char* tokenNames[];
#ifndef NO_STATIC_CONSTS
	static const int NUM_TOKENS = 78;
#else
	enum {
		NUM_TOKENS = 78
	};
#endif
	
	static const unsigned long _tokenSet_0_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_0;
	static const unsigned long _tokenSet_1_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_1;
	static const unsigned long _tokenSet_2_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_2;
};

#endif /*INC_ASTParser_hpp_*/
