#include <iostream>

#include "SysCall.h"

using namespace std;

//*******************************************************************
//*******************************************************************

void write(CHAR8 code, stack<SysCallPair>& argStack, CHAR8* baseData) {
	while (argStack.size() > 0) {
		SysCallPair op = argStack.top();
		INT32 type = op.first;
		INT32* value = op.second;
		
		if (type == STRING) {
			CHAR8* v = reinterpret_cast<CHAR8*>(baseData + *value);
			cout << v;
		}
		else if (type == INT) {
			cout << *value;
		}
		else if (type == FLOAT) {
			FLOAT32* v = reinterpret_cast<FLOAT32*>(value);
			cout << *v;
		}
		else if (type == CHAR) {
			CHAR8* v = reinterpret_cast<CHAR8*>(value);
			cout << *v;
		}
		else if (type == BOOL) {
			bool* v = reinterpret_cast<bool*>(value);
			cout << *v;
		}
		
		argStack.pop();
	}

	if (code == SYSCODE_WRITELN) cout << endl;
}

//*******************************************************************

void read(CHAR8 code, stack<SysCallPair>& argStack, CHAR8* baseData) {
	while (argStack.size() > 0) {
		SysCallPair op = argStack.top();
		INT32 type = op.first;
		INT32* addr = op.second;

		if (type == STRING) {
			char* str = reinterpret_cast<char*>(baseData + *addr);
			gets(str);
		}
		else if (type == INT) {
			int v;
			cin >> v;
			INT32* a = reinterpret_cast<INT32*>(baseData + *addr);
			*a = v;
		}
		else if (type == FLOAT) {
			float v;
			cin >> v;
			FLOAT32* a = reinterpret_cast<FLOAT32*>(baseData + *addr);
			*a = v;
		}
		else if (type == CHAR) {
			char c;
			cin >> c;
			CHAR8* a = reinterpret_cast<CHAR8*>(baseData + *addr);
			*a = c;
		}
		else if (type == BOOL) {
			bool b;
			cin >> b;
			CHAR8* a = reinterpret_cast<CHAR8*>(baseData + *addr);
			*a = b;
		}
		
		argStack.pop();
	}
}

//*******************************************************************

SYS_CALL_RESULT sysCall(CHAR8 code, stack<SysCallPair>& argStack, CHAR8* baseData) {
	switch (code) {
		case SYSCODE_WRITE:
		case SYSCODE_WRITELN: {
			write(code, argStack, baseData);
			break;
		}

		case SYSCODE_READ: {
			read(code, argStack, baseData);
			break;
		}
		
		default: return INVALID_SYS_CODE;
	}

	return SUCCESS;
}
