#include <cmath>

#include "Utilities.h"

using namespace std;

//*******************************************************************
//*******************************************************************

int Compiler::getTypeSizeFromTypeName(string name, SizeMetric metric) {
	int code = UNDEF_TYPE;
	if (name == CHAR) code = CHAR_CODE;
	else if (name == INT) code = INT_CODE;
	else if (name == FLOAT) code = FLOAT_CODE;
	else if (name == BOOL) code = BOOL_CODE;
	else if (name == VOID) code = VOID_CODE;

	int size = SIZE[code];
	
	if (metric == WORD && size > 0) {
		if (size >= WORD_SIZE) {
			return static_cast<int>(ceil(static_cast<double>(size) / WORD_SIZE));
		}
		else {
			return WORD_SIZE;
		}
	}

	return size;
}

//*******************************************************************

bool Compiler::isPrimitiveTypeAssignable(TypeCode left, TypeCode right) {
	bool same = left == right;
	bool charOrBoolToInt = left == INT_CODE && (right == CHAR_CODE || right == BOOL_CODE);
	bool boolToChar = left == CHAR_CODE && right == BOOL_CODE;
	bool charToBool = left == BOOL_CODE && right == CHAR_CODE;
	
	return same || charOrBoolToInt || boolToChar || charToBool;
}
